# Cart & Checkout Hooks

## `useIgCart()`

Use this hook if your site manages user carts through the Storefront **Cart** API.

Requires the `cartOrCheckoutToken` (cart ID). The hook will add cart attributes needed for experiments and optionally backfill currency based on the cart.

Returns a `wrapCustomAttributes` function. This function will add Intelligems-required line item properties to any existing line item properties (for example, for shipping tests).

<pre class="language-typescript" data-overflow="wrap"><code class="lang-typescript">interface WrapStorefrontItemCustomAttributesParams {
  productId?: string;
  variantId?: string;
  subscribeAndSave?: boolean;
  customAttributes?: {
    key: string;
    value: string;
  }[] | null;
};

interface WrapStorefrontItemCustomAttributesResponse {
  key: string;
  value: string;
}[];

<strong>const useIgCart: (cartOrCheckoutToken?: string | null) => {
</strong>  isReady: boolean;
  wrapCustomAttributes: (
    options: WrapStorefrontItemCustomAttributesParams
  ) => WrapStorefrontItemCustomAttributesResponse;
};
</code></pre>

## `useIgCartAttributes()`

Returns the attribute array you can attach when creating or updating carts in custom Storefront API flows.

```typescript
const useIgCartAttributes: () => {
  isReady: boolean;
  attributes: { key: string; value: string }[];
};
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://headless.intelligems.io/version-1.2.16/reference/hooks/cart-and-checkout-hooks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
